import com.sun.opengl.util.GLUT;
import java.awt.*;
import java.awt.event.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.GLU;
/**
* For our purposes only two of the
* GLEventListeners matter. Those would
* be init() and display().
*/
public class FirstPersonView implements GLEventListener, KeyListener
{
    double xPosition = 0;
    double zPosition = 0;
    double yPosition = 0;
    int anglex = 0;
    int angley = 0;

    float red = 0.0f;
    float green = 0.0f;
    float blue = 1.0f;
    GLCanvas glc;

     void setGLCanvas(GLCanvas glcanvas) {
        this.glc = glcanvas;
    }
/**
* Take care of initialization here.
*/

 public void init(GLAutoDrawable gld) {

    //The mode is GL.GL_MODELVIEW by default
    //We will also use the default ViewPort
    GLU glu = new GLU();
    GL gl = gld.getGL();

    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();

    // Aspect is width/height
    double w = ((Component) gld).getWidth();
    double h = ((Component) gld).getHeight();
    double aspect = w/h;
    //When using gluPerspective near and far need
    //to be positive.
    //The arguments are:
    //fovy, aspect, near, far
    glu.gluPerspective(60.0, aspect, 2.0, 20.0);
    }
/**
* Take care of drawing here.
*/
public void display(GLAutoDrawable drawable) {

    GL gl = drawable.getGL();
    GLU glu = new GLU();
    GLUT glut = new GLUT();

    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();

    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

    //Define points for eye, at and up.
    //This is your camera. It ALWAYS goes
    //in the GL_MODELVIEW matrix.
    glu.gluLookAt(
    xPosition, yPosition, zPosition,
    xPosition, yPosition, (zPosition+20),
    0, 1, 0
    );
    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    gl.glRotated(anglex, 1, 0, 0);
    gl.glRotated(angley, 0, 1, 0);

    red = 0.0f;
    green = 0.0f;
    blue = 0.9f;
    gl.glColor3f(red, green, blue);

    //transforming the place the next shape
    //will be drawn.
    gl.glTranslated(2, 0, 2);
    //We use wire here because default
    //lighting is not good enough to
    //use when rendering the solid version
    glut.glutWireIcosahedron();

    //more shapes to navigate through
    gl.glTranslated(-4, 0, 0);
    glut.glutWireIcosahedron();
    red = 0.0f;
    green = 0.9f;
    blue = 0.1f;
    gl.glColor3f(red, green, blue);
    gl.glTranslated(4, 0, 4);
    glut.glutWireIcosahedron();
    gl.glTranslated(-4, 0, 0);
    glut.glutWireIcosahedron();
    red = 0.9f;
    green = 0.0f;
    blue = 0.1f;
    gl.glColor3f(red, green, blue);
    gl.glTranslated(4, 0, 4);
    glut.glutWireIcosahedron();
    gl.glTranslated(-4, 0, 0);
    glut.glutWireIcosahedron();
    red = 0.9f;
    green = 0.0f;
    blue = 0.9f;
    gl.glColor3f(red, green, blue);
    gl.glTranslated(4, 0, 4);
    glut.glutWireIcosahedron();
    gl.glTranslated(-4, 0, 0);
    glut.glutWireIcosahedron();

    red = 0.5f;
    green = 0.5f;
    blue = 0.5f;
    gl.glColor3f(red, green, blue);
    gl.glTranslated(4, 0, 4);
    glut.glutWireIcosahedron();
    gl.glTranslated(-4, 0, 0);
    glut.glutWireIcosahedron();
    }
/**
* Called when the GLDrawable (GLCanvas
* or GLJPanel) has changed in size. We
* won't need this, but you may eventually
* need it -- just not yet.
*/
public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    }
/**
* If the display depth is changed while the
* program is running this method is called.
* Nowadays this doesn't happen much, unless
* a programmer has his program do it.
*/
public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
    }

    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == KeyEvent.VK_1)
        zPosition += 1;
        else if (e.getKeyChar() == KeyEvent.VK_2)
        zPosition -= 1;
        else if (e.getKeyChar() == KeyEvent.VK_3)
        xPosition += 1;
        else if (e.getKeyChar() == KeyEvent.VK_4)
        xPosition -= 1;
        else if (e.getKeyChar() == KeyEvent.VK_5)
        yPosition += 1;
        else if (e.getKeyChar() == KeyEvent.VK_6)
        yPosition -= 1;
        else if (e.getKeyChar() == KeyEvent.VK_7)
        anglex += 1;
        else if (e.getKeyChar() == KeyEvent.VK_8)
        anglex -= 1;
        else if (e.getKeyChar() == KeyEvent.VK_9)
        angley += 1;
        else if (e.getKeyChar() == KeyEvent.VK_0)
        angley -= 1;
        glc.repaint();

    }

    public void keyPressed(KeyEvent ke) {

    }

    public void keyReleased(KeyEvent ke) {

    }

}
