import com.sun.opengl.util.GLUT;
import java.awt.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.GLU;
import javax.media.opengl.glu.GLUquadric;
/**
* For our purposes only two of the
* GLEventListeners matter. Those would
* be init() and display().
*/
public class GLUObjectsView implements GLEventListener
{

/**
* Take care of initialization here.
*/

 public void init(GLAutoDrawable gld) {
//The mode is GL.GL_MODELVIEW by default
//We will also use the default ViewPort
    GLU glu = new GLU();
    GL gl = gld.getGL();

    //We're changing the mode to GL.GL_PROJECTION
    //This is where we set up the camera
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();

    // Aspect is width/height
    double w = ((Component) gld).getWidth();
    double h = ((Component) gld).getHeight();
    double aspect = w/h;
    //Notice we're not using gluOrtho2D.
    //When using gluPerspective near and far need
    //to be positive.
    //The arguments are:
    //fovy, aspect, near, far
    glu.gluPerspective(60.0, aspect, 2.0, 13.0);

    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    

    }
/**
* Take care of drawing here.
*/
public void display(GLAutoDrawable gld) {

    float red = 0.0f;
    float green = 0.0f;
    float blue = 0.9f;

    GL gl = gld.getGL();
    GLU glu = new GLU();

    //We're changing the mode to GL.GL_PROJECTION
    //the only JOGL methods that should be called
    //while using the GL_PROJECTION matrix are:
    // gluPerspective
    // glFrustum
    // glOrtho
    // gluOrtho2D
    // glLoadIdentity
    // glLoadMatrix
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();

    //Define points for eye, at and up.
    //This is your camera. It ALWAYS goes
    //in the GL_MODELVIEW matrix.
    glu.gluLookAt(
    0, 0, 4,
    0, 0, 0,
    0, 1, 0
    );

    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    gl.glColor3f(red, green, blue);

    //We use wire here because default
    //lighting is not good enough to
    //use when rendering the solid version
    //GLUT glut = new GLUT();
    //glut.glutWireIcosahedron();
    //The two lines above could be replaced
    //with the glu library code that follows.
    //This produces a line style sphere.
    GLUquadric quad = glu.gluNewQuadric();
    glu.gluQuadricDrawStyle(quad, GLU.GLU_LINE);
    //glu.gluSphere(quad, 1.0, 15, 15);
    //glu.gluCylinder(quad, 1.0, 1.0, 1.0, 15, 15);
    glu.gluDisk(quad, 1.0, 0.2, 50, 15);
    glu.gluDeleteQuadric(quad);

    }
/**
* Called when the GLDrawable (GLCanvas
* or GLJPanel) has changed in size. We
* won't need this, but you may eventually
* need it -- just not yet.
*/
public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    }
/**
* If the display depth is changed while the
* program is running this method is called.
* Nowadays this doesn't happen much, unless
* a programmer has his program do it.
*/
    public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
    }
}
