import com.sun.opengl.util.GLUT;
import java.awt.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.GLU;
/**
* For our purposes only two of the
* GLEventListeners matter. Those would
* be init() and display().
*/
public class LightingView implements GLEventListener
{
    int anglex = 0;
    int angley = 0;

    GLCanvas glc;

     void setGLCanvas(GLCanvas glcanvas) {
        this.glc = glcanvas;
    }
/**
* Take care of initialization here.
*/

 public void init(GLAutoDrawable gld) {  
    }
/**
* Take care of drawing here.
*/
public void display(GLAutoDrawable drawable) {

    GL gl = drawable.getGL();
    GLU glu = new GLU();
    GLUT glut = new GLUT();

    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();

    // Aspect is width/height
    double w = ((Component) drawable).getWidth();
    double h = ((Component) drawable).getHeight();
    double aspect = w/h;
    //When using gluPerspective near and far need
    //to be positive.
    //The arguments are:
    //fovy, aspect, near, far
    glu.gluPerspective(60.0, aspect, 2.0, 10.0);

    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();

    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

    //bleach out the scene with too much light.
    //Define points for eye, at and up.
    //This is your camera. It ALWAYS goes
    //in the GL_MODELVIEW matrix.
    glu.gluLookAt(
    0, 0, 0,
    0, 0, 20,
    0, 1, 0
    );
    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    
    //Time to set up the light. We will only
    //use one light. If we used multiple lights,
    //we would want to dim them so as to not
    float position[] = {0f, 15f, -30f, 0f};
    gl.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, position,0);

    float diffuse[] = {.7f,.7f,.7f,0f};
    gl.glLightfv(GL.GL_LIGHT0, GL.GL_DIFFUSE, diffuse,0);
    
    float ambient[] = {.2f,.2f,.2f,0f};
    gl.glLightfv(GL.GL_LIGHT0,GL.GL_AMBIENT,ambient,0);

  
    gl.glEnable(GL.GL_LIGHTING);
    gl.glEnable(GL.GL_LIGHT0);
    //GL_DEPTH_TEST prevents us from seeing polygons
    //that should be obscured. Remember to clear the
    //GL.GL_DEPTH_BUFFER_BIT
    gl.glEnable(GL.GL_DEPTH_TEST);

    //Notice the depth buffer bit is also being cleared
    gl.glClear(GL.GL_COLOR_BUFFER_BIT|GL.GL_DEPTH_BUFFER_BIT);

    gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);
    gl.glEnable(GL.GL_BLEND);

    gl.glShadeModel(GL.GL_SMOOTH);
    gl.glEnable(GL.GL_FOG);

    float fogColor[] = {0.5f, 0.5f, 0.5f, 1.0f};
    int fogMode = GL.GL_EXP;
    gl.glFogi(GL.GL_FOG_MODE, fogMode);  // Fog Mode
    gl.glFogfv(GL.GL_FOG_COLOR, fogColor, 0);  // Set Fog Color
    gl.glFogf(GL.GL_FOG_DENSITY, 0.1f);    // How Dense Will The Fog Be
    gl.glHint(GL.GL_FOG_HINT, GL.GL_DONT_CARE);  // Fog Hint Value
    gl.glFogf(GL.GL_FOG_START, 1.0f);    // Fog Start Depth
    gl.glFogf(GL.GL_FOG_END, 5.0f);      // Fog End Depth

    gl.glHint(GL.GL_POLYGON_SMOOTH_HINT,GL.GL_NICEST);
    //Placing icosahedron
    gl.glTranslated(0, -.3, 5);
    float material1[] = {0.9f, 0.6f, 0.06f, 1.0f};
    gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_AMBIENT_AND_DIFFUSE,material1,0);
    glut.glutSolidIcosahedron();

    
    //Placing cube
    gl.glTranslated(3, 0, 0);
    float material2[] = {0.9f,0f,0f,1.0f};
    gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT_AND_DIFFUSE, material2,0);
    glut.glutSolidCube(1.2f);

    //Placing sphere
    //The Cone parameters are:
    // radius of base
    // height of cone
    // slices or subdivisions around cone
    // stacks or subdivisions from base to peak
    gl.glTranslated(-6, 0, 0);
    float material3[] = {0.05f,0f,0.7f,1.0f};
    gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT_AND_DIFFUSE, material3,0);
    glut.glutSolidSphere(0.8, 100, 360);

    }
/**
* Called when the GLDrawable (GLCanvas
* or GLJPanel) has changed in size. We
* won't need this, but you may eventually
* need it -- just not yet.
*/
public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    }

    public void displayChanged(GLAutoDrawable glad, boolean bln, boolean bln1) {
    }
}
