import java.awt.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.GLU;
/**
* For our purposes only two of the
* GLEventListeners matter. Those would
* be init() and display().
*/
public class PlanesView implements GLEventListener
{

/**
* Take care of initialization here.
*/

 public void init(GLAutoDrawable gld) {
//The mode is GL.GL_MODELVIEW by default
//We will also use the default ViewPort
    GLU glu = new GLU();
    GL gl = gld.getGL();

    gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
    //Define points for eye, at and up.
    //This is your camera. It ALWAYS goes
    //in the GL_MODELVIEW matrix.
    glu.gluLookAt(
    20, 18, 0,
    20, 18, 30,
    0, 1, 0
    );

    }
/**
* Take care of drawing here.
*/
public void display(GLAutoDrawable gld) {

    float red = 1.0f;
    float green = 0.0f;
    float blue = 0.5f;

    GL gl = gld.getGL();
    GLU glu = new GLU();

    //We're changing the mode to GL.GL_PROJECTION
    //the only JOGL methods that should be called
    //while using the GL_PROJECTION matrix are:
    // gluPerspective
    // glFrustum
    // glOrtho
    // gluOrtho2D
    // glLoadIdentity
    // glLoadMatrix
    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();

    // Aspect is width/height
    double w = ((Component) gld).getWidth();
    double h = ((Component) gld).getHeight();
    double aspect = w/h;
    //Notice we're not using gluOrtho2D.
    //When using gluPerspective near and far need
    //to be positive.
    //The arguments are:
    //fovy, aspect, near, far
    glu.gluPerspective(60.0, aspect, 25.0, 55.0);

    gl.glMatrixMode(GL.GL_VIEWPORT);
    //we don't want to initialize the GL_MODELVIEW
    //using gl.glLoadIdentity() this time. It has
    //settings from the init() that we wish to keep.

    gl.glClear(GL.GL_COLOR_BUFFER_BIT);

    gl.glColor3f(red, green, blue);
    gl.glBegin(GL.GL_QUADS);
    //notice that the three squares are
    //exactly the same size. They appear
    //different on screen because of
    //perspective
    //1st Plane

    gl.glVertex3i(0, 30, 30);
    gl.glVertex3i(10, 30, 30);
    gl.glVertex3i(10, 20, 30);
    gl.glVertex3i(0, 20, 30);
    //2nd Plane
    gl.glVertex3i(20, 20, 37);
    gl.glVertex3i(30, 20, 37);
    gl.glVertex3i(30, 10, 37);
    gl.glVertex3i(20, 10, 37);
    //3rd Plane
    gl.glVertex3i(40, 10, 45);
    gl.glVertex3i(50, 10, 45);
    gl.glVertex3i(50, 0, 45);
    gl.glVertex3i(40, 0, 45);

    gl.glEnd();
    }
/**
* Called when the GLDrawable (GLCanvas
* or GLJPanel) has changed in size. We
* won't need this, but you may eventually
* need it -- just not yet.
*/
public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    }
/**
* If the display depth is changed while the
* program is running this method is called.
* Nowadays this doesn't happen much, unless
* a programmer has his program do it.
*/
 public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
    }
}
