import java.awt.*;
import javax.swing.*;
import javax.media.opengl.*;
/**
* This is a basic JOGL app. Feel free to
* reuse this code or modify it.
*/
public class Room extends JFrame {

    static GLCanvas glcanvas = null;

    public static void main(String[] args) {
        final Room app = new Room();
        // show what we've done
        SwingUtilities.invokeLater (
        new Runnable() {
        public void run() {
        app.setVisible(true);
        //app.setResizable (false);
        }
        }
        );
    }
    public Room() {
        //set the JFrame title
        super("Room");

        //create our KeyDisplay which serves two purposes
        // 1) it is our GLEventListener, and
        // 2) it is our KeyListener
        RoomView rv = new RoomView();

        //kill the process when the JFrame is closed
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //only three JOGL lines of code ... and here they are
        GLCapabilities glcaps = new GLCapabilities();
        glcanvas = new GLCanvas();
        glcanvas.addGLEventListener(rv);
        glcanvas.addKeyListener(rv);

        //we'll want this for our repaint requests
        rv.setGLCanvas(glcanvas);

        //add the GLCanvas just like we would any Component
        getContentPane().add(glcanvas, BorderLayout.CENTER);
        setSize(800, 500);
        //center the JFrame on the screen
        centerWindow(this);
    }
    public void centerWindow(Component frame) {
        Dimension screenSize =
        Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.width > screenSize.width )
        frameSize.width = screenSize.width;
        if (frameSize.height > screenSize.height)
        frameSize.height = screenSize.height;
        frame.setLocation (
        (screenSize.width - frameSize.width ) >> 1,
        (screenSize.height - frameSize.height) >> 1
        );
    }
}