import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureIO;
import java.io.File;
import javax.media.opengl.*;
import javax.media.opengl.glu.GLU;
import javax.media.opengl.glu.GLUquadric;

public class SolarSystemView implements GLEventListener
{
	private static float t=0,k=0;
	private float w=1,h=1;
        private Texture earthTexture;
        private Texture marsTexture;
        private Texture venusTexture;
        private Texture sunTexture;
        private GLUquadric  quadric;


    GLCanvas glc;


     void setGLCanvas(GLCanvas glcanvas) {
        this.glc = glcanvas;
    }
/**
* Take care of initialization here.
*/

 public void init(GLAutoDrawable gld) {

GL gl=gld.getGL();
			gl.glEnable(GL.GL_LIGHTING);

			float ambient[]= {0.2f,0.2f,0.2f,1};
			gl.glLightModelfv(GL.GL_LIGHT_MODEL_AMBIENT , ambient,0);

			gl.glEnable(GL.GL_LIGHT0);
			float position1[]= {-0.5f,0,00,1};
			gl.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, position1, 0);
			float intensity1[]= {1,1,1,1};
			gl.glLightfv(GL.GL_LIGHT0, GL.GL_DIFFUSE, intensity1, 0);
			float specIntensity2[]= {1,1,1,1};
			gl.glLightfv(GL.GL_LIGHT0, GL.GL_SPECULAR, specIntensity2, 0);


			gl.glEnable(GL.GL_COLOR_MATERIAL);
			gl.glColorMaterial(GL.GL_FRONT_AND_BACK, GL.GL_AMBIENT_AND_DIFFUSE);
			float specColor[]= {1,1,1,1};
			gl.glMaterialfv(GL.GL_FRONT_AND_BACK,GL.GL_SPECULAR, specColor,0);
			gl.glMaterialf(GL.GL_FRONT_AND_BACK,GL.GL_SHININESS, 80);

                        earthTexture = load("earth.jpg");
                        marsTexture = load("mars.jpg");
                        venusTexture = load("venus.png");
                        sunTexture = load("sun.jpg");
    }

/**
* Take care of drawing here.
*/
public void display(GLAutoDrawable gld) {



			GL gl=gld.getGL();
			gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);

			gl.glEnable(GL.GL_DEPTH_TEST);
			gl.glCullFace(GL.GL_FRONT);
			gl.glEnable(GL.GL_CULL_FACE);
			gl.glFrontFace(GL.GL_CW);

			gl.glMatrixMode(GL.GL_PROJECTION);
			gl.glLoadIdentity();
			gl.glScalef(600/w, 600/h, 1);

			//Projective transform
			GLU glu=new GLU();
			glu.gluPerspective(50.0f, 1, 1.0, 20.0);
			gl.glTranslatef(0, 0, -10);
			gl.glRotatef(0.2f*t,0,1,0);
                        t++;
			

			gl.glMatrixMode(GL.GL_MODELVIEW);
			gl.glLoadIdentity();

			quadric=glu.gluNewQuadric();
                        glu.gluQuadricTexture(quadric, true);

                        gl.glLoadIdentity();
			gl.glTranslatef(0.5f,0,6);
                        gl.glRotated(90, 1, 0, 0);
                        gl.glRotatef(90*k, 0, 0, 1);

				gl.glColor3f(1,1,1);
                                marsTexture.enable();
                                marsTexture.bind();
				glu.gluSphere(quadric, 0.8f, 16, 16); //mars
                                marsTexture.disable();

                         gl.glLoadIdentity();
			gl.glTranslatef(-0.8f,0,2.5f);
                        gl.glRotated(90, 1, 0, 0);
                        gl.glRotatef(90*k, 0, 0, 1);

				//gl.glColor3f(1,1,1);
                                venusTexture.enable();
                                venusTexture.bind();
				glu.gluSphere(quadric, 0.2f, 10, 10);//venus
                                venusTexture.disable();

			 gl.glLoadIdentity();
			gl.glTranslatef(-0.2f,0,-4);
                        gl.glRotated(90, 1, 0, 0);
                        gl.glRotatef(90*k, 0, 0, 1);

				//gl.glColor3f(1,1,1);
                                earthTexture.enable();
                                earthTexture.bind();
				glu.gluSphere(quadric, 0.6f, 10, 10);//earth
                                earthTexture.disable();

			gl.glDisable(GL.GL_LIGHTING);


                         gl.glLoadIdentity();
			gl.glTranslatef(-0.5f,0,0);
                         gl.glRotated(90, 1, 0, 0);

				gl.glColor3f(1,1,0);
                                sunTexture.enable();
                                sunTexture.bind();
				glu.gluSphere(quadric, 1f, 16, 16);
                                sunTexture.disable();


                                k=k+0.01f;
			gl.glEnable(GL.GL_LIGHTING);
    }

/**
* Called when the GLDrawable (GLCanvas
* or GLJPanel) has changed in size. We
* won't need this, but you may eventually
* need it -- just not yet.
*/
public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    GL gl=drawable.getGL();

			w=width;
			h=height;
    }

    public void displayChanged(GLAutoDrawable glad, boolean bln, boolean bln1) {
    }



Texture load(String filename){
    Texture texture = null;

      try
      {
          // Create an OpenGL texture from the specified file. Do not create
          // mipmaps.

          texture = TextureIO.newTexture (new File (filename), false);

          // Use the NEAREST magnification function when the pixel being
          // textured maps to an area less than or equal to one texture
          // element (texel).

          texture.setTexParameteri (GL.GL_TEXTURE_MAG_FILTER, GL.GL_NEAREST);

          // Use the NEAREST minification function when the pixel being
          // textured maps to an area greater than one texel.

          texture.setTexParameteri (GL.GL_TEXTURE_MIN_FILTER, GL.GL_NEAREST);
      }
      catch (Exception e)
      {
          System.out.println ("error loading texture from "+filename);
      }

      return texture;
 }
}